<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddTagnotisToGadaiTable extends Migration
{
    public function getActiveDB(){
        $config_db = array_keys(config("database.connections"));

        $db_connection = array_filter($config_db,function($connection){
            try{
                if($connection == 'mysql7')
                    return false;

                $db = DB::connection($connection)->getPdo();
                return true;
            } catch(\Exception $e){
                return false;
            }
        });
        return $db_connection;
    }

    public function up()
    {
        $db_connection = $this->getActiveDB();

        foreach($db_connection as $dbase){
            Schema::connection($dbase)->table('gadai', function (Blueprint $table) use($dbase) {

                $isTagNotisExist = Schema::connection($dbase)->hasColumn('gadai', 'tagnotis');


                if(! $isTagNotisExist){
                    $table->tinyInteger('tagnotis')->default(0);
                }

            });
        }

    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        $db_connection = $this->getActiveDB();

        foreach($db_connection as $dbase){
            $columns = ['tagnotis'];


            $columns_exist = array_filter($columns,function($column) use($dbase){
                return Schema::connection($dbase)->hasColumn('gadai', $column);
            });

            Schema::connection($dbase)->table('gadai', function(Blueprint $table) use($columns_exist){
                foreach($columns_exist as $column){
                        $table->dropColumn($column);
                }
            });
        }
    }
}